package org.insa.graphs.algorithm.shortestpath;

import org.insa.graphs.algorithm.AbstractInputData.Mode;
import org.insa.graphs.model.LabelStar;
import org.insa.graphs.model.Node;

public class AStarAlgorithm extends DijkstraAlgorithm {

    public AStarAlgorithm(ShortestPathData data) {
        super(data);
    }
    
    @Override
    protected void initAlgo() {
    	
        // Dijkstra guidée init
        this.labels = new LabelStar[data.getGraph().size()];
        
        if(data.getMode() == Mode.TIME) {
        	//time based, need to set LabelStar with maxspeed
            for(Node node : data.getGraph().getNodes()) {
            	labels[node.getId()] = new LabelStar(node, getInputData().getDestination(), data.getGraph().getGraphInformation().getMaximumSpeed());
            }
        }
        else {
            for(Node node : data.getGraph().getNodes()) {
            	labels[node.getId()] = new LabelStar(node, getInputData().getDestination());
            }
        }

    }

}
