package org.insa.graphs.model;

public class Label implements Comparable<Label>{

		protected Node current;
		protected boolean marked;
		protected double cost;
		protected Arc father;
		
		
		public Label(Node current) {
			this.current = current;
			this.cost    = Double.POSITIVE_INFINITY;
			this.father  = null;
			this.marked  = false;
		}
		
		public void setNewCost(Arc father, double cost) {
			this.father = father;
			this.cost   = cost;
		}
		
		
		public void setMarked() {
			this.marked = true;
		}
		
		public boolean isMarked() {
			return this.marked;
		}
		
		public double getCost() {
			return this.cost;
		}
		
		public Node getCurrent() {
			return this.current;
		}
		
		public Arc getFather() {
			return this.father;
		}

		public double getMinCostToDestination() {
			return 0; // not used in Label but only in LabelStar
		}
		
		// We calculate the cost to reach destination only if needed
		public int compareTo(Label arg0) {
			//In this case, the comparison is based on cost to reach the node + min cost to reach dest
			return Double.compare(this.cost + getMinCostToDestination(), arg0.cost + arg0.getMinCostToDestination());
		}
	
}
