package org.insa.graphs.model;

public class LabelStar extends Label {

	protected double minCostToDestination = -1;
	protected Node destination;
	protected double maxSpeedPossible = -1;
	
	public LabelStar(Node current, Node destination) {
		super(current);
		this.destination = destination;
	}	
	
	public LabelStar(Node current, Node destination, double maxSpeed) {
		super(current);
		this.destination = destination;
		this.maxSpeedPossible = maxSpeed;
	}

	public double getMinCostToDestination() {
		if(this.minCostToDestination < 0) {
			//need to calculate
			
			if(this.maxSpeedPossible > 0) {
				//if maxspeedpossible is initialized, then we use time shortest
				this.minCostToDestination = this.current.getPoint().distanceTo(this.destination.getPoint()) / this.maxSpeedPossible;
			}
			else {
				//if maxspeedpossible is not initialized, then we use shortest path
				this.minCostToDestination = this.current.getPoint().distanceTo(this.destination.getPoint());

			}
			
			
		}
		return this.minCostToDestination;
	}
	
}
